/*

  in_cube Gamecube Stream Player for Winamp
  by hcs

  includes work by Destop and bero

*/

// VAG (Sony "Very Audio Good")

#include <windows.h>
#include "wamain.h"
#include "cube.h"

// inputfile == NULL means file is already opened, just reload
// return 1 if valid VAG not detected, 0 on success
int InitVAGFILE(char * inputfile, CUBEFILE * vag) {
	int l,i;
	unsigned char readbuf[0x80];
	int MaskID=0,temp_MaskID=0,temp_id=0;
	char infile[MAX_PATH],infile2[MAX_PATH]; // file name, second file name (for dual-file stereo)
	int dfs=-1; // dual-file stereo (0 if we have the name of left channel, 1 if right)
	char * ext, * ext2;
	HANDLE mihFile=0;

	vag->loopsamplesdone=0;
	vag->samplesdone=0;
	vag->uncompressed=0;
	vag->ch[0].offs=0;
	vag->ch[0].hist1 = vag->ch[0].hist2 = 0;
	vag->ch[1].hist1 = vag->ch[1].hist2 = 0;
	vag->ch[0].readloc=vag->ch[1].readloc=0;
	vag->ch[0].writeloc=vag->ch[1].writeloc=0;
	vag->ch[0].bps=vag->ch[1].bps=8;
	vag->ch[0].ea=vag->ch[0].sa=0;
	vag->ch[1].ea=vag->ch[1].sa=0;
	vag->ch[0].loop_flag=vag->ch[1].loop_flag=0;

	if (inputfile) {
		vag->ch[0].infile=vag->ch[1].infile=INVALID_HANDLE_VALUE;

		//if (strcmpi(inputfile+strlen(inputfile)-4,".vag")) return 1;

		vag->ch[0].infile = CreateFile(inputfile,GENERIC_READ,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,
			OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);

		if (vag->ch[0].infile == INVALID_HANDLE_VALUE) // error opening file
			return 1;

	} else if (vag->ch[0].type!=type_vag) return 1; // we don't have the file name to recheck

	vag->file_length=GetFileSize(vag->ch[0].infile,NULL);
	vag->ch[1].infile=vag->ch[0].infile;

	// Check by extension ...
	if (!strcmpi(inputfile+strlen(inputfile)-4,".mib") && !strcmpi(inputfile+strlen(inputfile)-4,".MIB"))
	{
		// Search for .MIH
		strcpy(infile,inputfile);
		infile[strlen(infile)-3]='M';
		infile[strlen(infile)-2]='I';
		infile[strlen(infile)-1]='H';
		mihFile = CreateFile(infile,GENERIC_READ,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,
			OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
		if(mihFile!=INVALID_HANDLE_VALUE)
		{
			ReadFile(mihFile, &readbuf, 0x80,&l,NULL);
            vag->NCH = get32bitL(readbuf + 0x08);
			vag->ch[0].sample_rate = vag->ch[1].sample_rate = get32bitL(readbuf + 0x0C);
			vag->ch[0].interleave = vag->ch[1].interleave = get32bitL(readbuf + 0x10);
			vag->ch[0].sa = get32bitL(readbuf + 0x14);
			vag->ch[0].ea = vag->file_length;
			vag->ch[0].loop_flag= !(vag->ch[0].sa==0);
            vag->ch[0].type = type_mib;
            vag->nrsamples =(vag->file_length/16*14);
			vag->ch[0].chanstart=0;
			vag->ch[1].chanstart=vag->ch[0].chanstart+vag->ch[0].interleave;
		}
		else
		{
		
			// try to catch the interleave ...
			ReadFile(vag->ch[0].infile, &MaskID, 4,&l,NULL);
			SetFilePointer(vag->ch[0].infile,0x0c,0,FILE_CURRENT);
			vag->ch[0].interleave=0;

			do
			{
				//lblInterleave.Text = "Searching Interleave @ 0x" + m_ADPCMFile.Interleave.ToString("x");
				//Application.DoEvents();

				ReadFile(vag->ch[0].infile, &temp_MaskID, 4,&l,NULL);

				for (i = 0; i < 3; i++)
					ReadFile(vag->ch[0].infile, &temp_id, 4,&l,NULL);

				vag->ch[0].interleave += 0x10;
            
				if (SetFilePointer(vag->ch[0].infile,0,0,FILE_CURRENT) >= (vag->file_length))
					break;

			} while (!((temp_MaskID == MaskID) && (temp_id == 0)));

			if ((vag->ch[0].interleave <=(long)(vag->file_length - 0x20))
				&& (vag->ch[0].interleave > 0x20) && (vag->ch[0].interleave <= 0x20000))
			{
				vag->ch[0].type = type_mib;
				vag->ch[1].interleave=vag->ch[0].interleave;
				vag->NCH=2;
				vag->ch[0].sample_rate=44100;
				vag->ch[0].offs = 0; //0x10;
				vag->nrsamples = ((vag->file_length / 16) * 28)/2;
				vag->ch[0].chanstart=0;
				vag->ch[1].chanstart=vag->ch[0].chanstart+vag->ch[0].interleave;
			}
		}
	}
	// Check by extension ...
	if (!strcmpi(inputfile+strlen(inputfile)-4,".mic") && !strcmpi(inputfile+strlen(inputfile)-4,".MIC"))
	{
		ReadFile(vag->ch[0].infile, readbuf, 0x80,&l,NULL);

		vag->ch[0].chanstart=get32bitL(readbuf);
		vag->NCH=get32bitL(readbuf+0x08);
		vag->nrsamples=((vag->file_length / 16) * 28)/vag->NCH;
		vag->ch[0].sample_rate=vag->ch[1].sample_rate=get32bitL(readbuf+0x0c);
		vag->ch[0].interleave=vag->ch[1].interleave=get32bitL(readbuf+0x10);
		vag->ch[1].chanstart=vag->ch[0].chanstart+vag->ch[0].interleave;
		vag->ch[0].type=vag->ch[1].type=type_mib;
	}
	else if (!strcmpi(inputfile+strlen(inputfile)-4,".ccc") && !strcmpi(inputfile+strlen(inputfile)-4,".CCC"))
	{
		ReadFile(vag->ch[0].infile, readbuf, 0x80,&l,NULL);
        if ((get32bitL(readbuf+0x40) == (int)0xCCCCCCCC) && 
			(get32bitL(readbuf+0x44) == (int)0xCCCCCCCC) && 
			(get32bitL(readbuf+0x48) == (int)0xCCCCCCCC) && 
			(get32bitL(readbuf+0x4C) == (int)0xCCCCCCCC))
        {
            vag->NCH = 2;
			vag->ch[0].loop_flag=0;
            vag->ch[0].type = type_ccc;
            vag->ch[0].sample_rate = vag->ch[1].sample_rate = get32bitL(readbuf + 0x04);
            vag->ch[0].interleave = vag->ch[1].interleave = 0x2000;
            vag->ch[0].chanstart = 0x50;
			vag->ch[1].chanstart = 0x2050;
            vag->nrsamples =(get32bitL(readbuf+0x08)/16)*28/2;
        }
		else
		{
			CloseCUBEFILE(vag);
			return 1;
		}
	}
	else if (!strcmpi(inputfile+strlen(inputfile)-4,".ass") && !strcmpi(inputfile+strlen(inputfile)-4,".ASS"))
	{
		ReadFile(vag->ch[0].infile, readbuf, 0x80,&l,NULL);
        if ((get32bitL(readbuf+0x00) <= 0x02) && 
			(get32bitL(readbuf+0x04) != 0) && 
			(get32bitL(readbuf+0x04) <= (int)0xbb80))
        {
            vag->NCH = get32bitL(readbuf+0x00);
			vag->ch[0].loop_flag=0;
            vag->ch[0].type = type_ass;
            vag->ch[0].sample_rate = vag->ch[1].sample_rate = get32bitL(readbuf + 0x04);
			
			vag->nrsamples = (get32bitL(readbuf + 0x08)/16)*28;

            vag->ch[0].interleave = vag->ch[1].interleave = get32bitL(readbuf + 0x0C);
            vag->ch[0].chanstart = 0x800;
			vag->ch[1].chanstart = vag->ch[0].chanstart + vag->ch[0].interleave;
        }
		else
		{
			CloseCUBEFILE(vag);
			return 1;
		}
	}
	else if (!strcmpi(inputfile+strlen(inputfile)-4,".tgt") && !strcmpi(inputfile+strlen(inputfile)-4,".TGT"))
	{
        vag->NCH = 2;
		vag->ch[0].loop_flag=0;
        vag->ch[0].type = type_svag;
        vag->ch[0].sample_rate = vag->ch[1].sample_rate = 44100;
        vag->ch[0].interleave = vag->ch[1].interleave = 0x400;
        vag->ch[0].chanstart = 0x0;
		vag->ch[1].chanstart = 0x400;
        vag->nrsamples =((vag->file_length)/16)*28/2;
		SetFilePointer(vag->ch[0].infile,vag->file_length-0x10,0,FILE_BEGIN);
		ReadFile(vag->ch[0].infile, readbuf, 0x4,&l,NULL);
        if (get16bitL(readbuf) != (int)0x0c)
		{
			vag->ch[0].sa=vag->ch[1].sa=0;
			vag->ch[0].loop_flag=1;
			vag->ch[0].ea=vag->ch[1].ea=vag->file_length;		
		}
	}
	else if (!strcmpi(inputfile+strlen(inputfile)-3,".vs") && !strcmpi(inputfile+strlen(inputfile)-3,".VS"))
	{
		ReadFile(vag->ch[0].infile, readbuf, 0x80,&l,NULL);
        if (get32bitL(readbuf) == (int)0x000000C8)
        {
            vag->ch[0].type= type_vs;
            vag->ch[0].chanstart = 0x08;
            vag->NCH = 2;
            vag->ch[0].sample_rate=vag->ch[1].sample_rate = get32bitL(readbuf+0x04);
            vag->nrsamples=(vag->file_length/16)*28/2;
            vag->ch[0].interleave = vag->ch[1].interleave = get32bitL(readbuf+0x08);
			vag->ch[1].chanstart=vag->ch[0].chanstart+vag->ch[0].interleave;
        }
		else
		{
			CloseCUBEFILE(vag);
			return 1;
		}
	}
	else if (!strcmpi(inputfile+strlen(inputfile)-4,".fag") && !strcmpi(inputfile+strlen(inputfile)-4,".FAG"))
	{
		ReadFile(vag->ch[0].infile, readbuf, 0x80,&l,NULL);

        if (get32bitL(readbuf) == (int)0x00000001)
		{
            vag->ch[0].type = type_fag;
            vag->nrsamples = ((vag->file_length-0x800) / 16) * 28/2;
            vag->NCH = 2;
            vag->ch[0].sample_rate=vag->ch[1].sample_rate = 24000;
            vag->ch[0].chanstart=0x800;
            vag->ch[0].interleave=vag->ch[1].interleave= 0x8000;
			vag->ch[1].chanstart=vag->ch[0].chanstart+vag->ch[0].interleave;
        }
		else
		{
			CloseCUBEFILE(vag);
			return 1;
		}
	}
	else if (!strcmpi(inputfile+strlen(inputfile)-4,".psh") && !strcmpi(inputfile+strlen(inputfile)-4,".PSH"))
	{
		ReadFile(vag->ch[0].infile, &MaskID, 4,&l,NULL);
        if ((MaskID & 0xff00ff00) == 0x00004000)
        {
			ReadFile(vag->ch[0].infile,readbuf,0x80,&l,NULL);
            vag->NCH = 2;
			// Have to check the loop point for this one ...
			//vag->ch[0].ea = (get16bit(readbuf) * 0x20) + 0x800;
			//vag->ch[0].sa = (get16bit(readbuf+0x02) << 1) ;
            //vag->ch[0].loop_flag = (vag->ch[0].sa != 0);
			vag->ch[0].loop_flag=0;
            vag->ch[0].type = type_psh;
            vag->ch[0].sample_rate = vag->ch[1].sample_rate = (u32)get16bitL(readbuf + 0x04);
            vag->ch[0].interleave = vag->ch[1].interleave = 0x800;
            vag->ch[0].chanstart = 0x0;
			vag->ch[1].chanstart = 0x800;
            vag->nrsamples = ((vag->file_length / 16) * 28)/2;
        }
		else
		{
			CloseCUBEFILE(vag);
			return 1;
		}
	}
	else if (!strcmpi(inputfile+strlen(inputfile)-4,".i80") && !strcmpi(inputfile+strlen(inputfile)-4,".I80"))
	{
        vag->NCH = 2;
		vag->ch[0].loop_flag=0;
        vag->ch[0].type = type_i80;
        vag->ch[0].sample_rate = vag->ch[1].sample_rate = 44100;
        vag->ch[0].interleave = vag->ch[1].interleave = 0x800;
        vag->ch[0].chanstart = 0x0;
		vag->ch[1].chanstart = 0x800;
        vag->nrsamples = ((vag->file_length / 16) * 28)/2;
	}
	else if (!strcmpi(inputfile+strlen(inputfile)-5,".i100") && !strcmpi(inputfile+strlen(inputfile)-5,".I100"))
	{
		// i know this kind of code sucks, but as their is no header
		// i don't know how to do ... :(
        vag->NCH = 2;
		vag->ch[0].loop_flag=0;
        vag->ch[0].type = type_i100;
        vag->ch[0].sample_rate = vag->ch[1].sample_rate = 32000;
        vag->ch[0].interleave = vag->ch[1].interleave = 0x1000;
        vag->ch[0].chanstart = 0x0;
		vag->ch[1].chanstart = 0x1000;
        vag->nrsamples = ((vag->file_length / 16) * 28)/2;
	}
	else if (!strcmpi(inputfile+strlen(inputfile)-4,".psw") && !strcmpi(inputfile+strlen(inputfile)-4,".PSW"))
	{
		ReadFile(vag->ch[0].infile,readbuf,0x80,&l,NULL);

		if ((!memcmp(readbuf,"RIFF",4)) && (!memcmp(readbuf+ 0x08,"WAVEfmt ",8)))
		{
			if ((get16bitL(readbuf + 0x14)==0xffff) && (get32bitL(readbuf+0x10)==0x0012))
			{
				vag->NCH = get16bitL(readbuf + 0x16);
				vag->ch[0].loop_flag=0;
				vag->ch[0].type = type_psw;
				vag->ch[0].sample_rate = vag->ch[1].sample_rate = get16bitL(readbuf + 0x18);
				vag->ch[0].interleave = vag->ch[1].interleave = 0x6400;
				vag->ch[0].chanstart = 0x2e;
				vag->ch[1].chanstart = vag->ch[0].chanstart + vag->ch[0].interleave;
				vag->nrsamples = ((get32bitL(readbuf + 0x04) / 16) * 28)/2;
			}
		}
	}
	else if (!strcmpi(inputfile+strlen(inputfile)-4,".rkv") && !strcmpi(inputfile+strlen(inputfile)-4,".RKV"))
	{
		ReadFile(vag->ch[0].infile,readbuf,0x80,&l,NULL);

		if ((get32bitL(readbuf)==0) && ((get32bitL(readbuf+ 0x10)==0) || (get32bitL(readbuf+ 0x10)==1)))
		{
			if ((get32bitL(readbuf + 0x04)>=11025) && (get32bitL(readbuf+0x04)<=44100))
			{
				vag->NCH = get16bitL(readbuf + 0x10)+1;
				vag->ch[0].type = type_rkv;
				vag->ch[0].sample_rate = vag->ch[1].sample_rate = get16bitL(readbuf + 0x04);
				vag->ch[0].interleave = vag->ch[1].interleave = 0x400;

				vag->ch[0].loop_flag=0;
				vag->ch[0].sa=get32bitL(readbuf + 0x08);
				vag->ch[0].ea=(get32bitL(readbuf + 0x0c)*16/28);

				if (vag->ch[0].sa==0xFFFFFFFF)
					vag->ch[0].loop_flag=0;
//				else
//					vag->ch[0].sa;

				vag->ch[0].chanstart = 0x800;
				vag->ch[1].chanstart = vag->ch[0].chanstart + vag->ch[0].interleave;
				vag->nrsamples = get32bitL(readbuf + 0x0c);
			}
		}
	}
	else
	{
		ReadFile(vag->ch[0].infile,readbuf,0x80,&l,NULL);
		
		if (!memcmp(readbuf,"VAGp",4)) {
			vag->ch[0].type=type_vag;
			vag->NCH = 1;
			vag->ch[0].sample_rate = get32bit(readbuf+0x10);
			vag->ch[0].loop_flag=0;
			vag->nrsamples = get32bit(readbuf+0xc)*28/16;
			vag->ch[0].chanstart=0x40;

			// Dual file stereo
			strcpy(infile,inputfile);
			ext=strrchr(infile,'.')+1;
			strcpy(infile2,infile);
			ext2=ext-infile+infile2;
			ext2[-1]='\0';
			if (!strcmpi(ext2-2,"L")) { 
				ext2[-2]='R';
				dfs=0;
			} else if (!strcmpi(ext2-2,"R")) {
				ext2[-2]='L';
				dfs=1;
			} 

			infile2[strlen(infile2)]='.';
			
			if (dfs==0) { // left channel already opened, load right
				vag->ch[1].infile=CreateFile(infile2,GENERIC_READ,
				FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
				
				if (vag->ch[1].infile==INVALID_HANDLE_VALUE) 
					vag->ch[1].infile=vag->ch[0].infile;
			} else if (dfs==1) { // right channel already opened, load left
				vag->ch[1].infile=vag->ch[0].infile;
				vag->ch[0].infile=CreateFile(infile2,GENERIC_READ,
				FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
				
				if (vag->ch[0].infile==INVALID_HANDLE_VALUE) 
					vag->ch[0].infile=vag->ch[1].infile;
			} else vag->ch[1].infile=vag->ch[0].infile;

			if (vag->ch[0].infile!=vag->ch[1].infile)
			{
				vag->ch[0].type=type_vag_2ch;
				vag->NCH=2;
				vag->ch[1].sample_rate=vag->ch[0].sample_rate;
				vag->ch[1].chanstart=vag->ch[0].chanstart;
				vag->ch[0].interleave=vag->ch[1].interleave=0x10;
			}


		} else if (!memcmp(readbuf,"SShd",4) && !memcmp(readbuf+0x20,"SSbd",4)) {

			vag->ch[0].type=type_ads;
			vag->uncompressed=(get32bitL(readbuf+0x08) != 0x10);
			vag->NCH = get32bitL(readbuf+0x10);
			vag->ch[1].sample_rate = vag->ch[0].sample_rate = get32bitL(readbuf+0xc);
		    
			vag->ch[1].interleave=vag->ch[0].interleave=get32bitL(readbuf+0x14);
			vag->ch[0].chanstart=0x28;
			vag->ch[1].chanstart=0x28+vag->ch[0].interleave;
			
			if (vag->uncompressed==0)
				vag->nrsamples = get32bitL(readbuf+0x24)*28/16/vag->NCH;
			else
				vag->nrsamples = get32bitL(readbuf+0x24)/(2*vag->NCH);

			// mmm... not sure of the loop flag :P
			// vag->ch[0].loop_flag = vag->ch[1].loop_flag = (vag->ch[0].sa<vag->ch[0].ea);

		} else if(!memcmp(readbuf, "NPSF", 4)) {
			// Namco Ace Combat Radio & BGM format
			vag->ch[0].type=type_npsf;
			vag->NCH = get32bitL(readbuf+0xc);
			vag->ch[1].sample_rate = vag->ch[0].sample_rate = get32bitL(readbuf+0x18);

			// 2007-11-11 - Fastelbja : nrsamples count fixed
			vag->nrsamples = get32bitL(readbuf+0x8)*28/16;

			// 2007-11-11 - Fastelbja : interleave (*2) is on 0x04 
			vag->ch[1].interleave=vag->ch[0].interleave=get32bitL(readbuf+0x04)/2;

			// HACK
			if(vag->NCH == 1)
				vag->ch[1].interleave=vag->ch[0].interleave=0xffffffff;
			
			// 2007-11-11 - Fastelbja : chanstart value is on 0x10
			vag->ch[0].chanstart=get32bitL(readbuf + 0x10);
			vag->ch[1].chanstart=vag->ch[0].chanstart+vag->ch[0].interleave;

			// 2007-11-11 - Fastelbja : Loop entry point is on 0x14
			//							End loop point is always end of file
			vag->ch[0].sa=vag->ch[1].sa=get32bitL(readbuf + 0x14);
			vag->ch[0].ea=vag->ch[1].ea=vag->file_length;
			
			if (vag->ch[0].sa==0xffffffff)
			{
				vag->ch[0].loop_flag=vag->ch[1].loop_flag=0;
				vag->ch[0].ea=vag->ch[1].ea=0;
				vag->ch[0].sa=vag->ch[1].sa=0;
			}
			else
				vag->ch[0].loop_flag = vag->ch[1].loop_flag = 1;

			
		}
		else if(get32bitL(readbuf)== (int)0x0000080d) 
		{
			// RWS (Ghost Rider)
			vag->file_length = get32bitL(readbuf+0x04);
			vag->nrsamples = (vag->file_length*28/16)/2;
			vag->ch[0].type=type_rws;
			vag->NCH = 2;
			vag->ch[1].sample_rate = vag->ch[0].sample_rate = 44100;

			vag->ch[1].interleave=vag->ch[0].interleave=get32bitL(readbuf+0x4c)/2;

			vag->ch[0].chanstart=get32bitL(readbuf+0x48);
			vag->ch[1].chanstart=vag->ch[0].chanstart+vag->ch[0].interleave;

		} else if(!memcmp(readbuf, "pGAV", 4) && !memcmp(readbuf+0x20, "Stereo", 6)) {
			// Stereo VAG
			vag->ch[0].type=type_svag;
			vag->NCH = 2;
			vag->ch[1].sample_rate = vag->ch[0].sample_rate = get32bitL(readbuf+0x10);

			vag->nrsamples = (get32bitL(readbuf+0x0C)*28/16)/2;
			vag->ch[1].interleave=vag->ch[0].interleave=0x2000;

			vag->ch[0].chanstart=0x0;
			vag->ch[1].chanstart=vag->ch[0].chanstart+vag->ch[0].interleave;
			vag->ch[0].loop_flag = vag->ch[1].loop_flag = 0;
		}	
		else if(!memcmp(readbuf, "RXWS", 4)) {
			// Namco Ace Combat Radio & BGM format
			vag->ch[0].type=type_rxws;
			vag->NCH = 2;
			vag->ch[1].sample_rate = vag->ch[0].sample_rate = get32bitL(readbuf+0x2E);

			// 2007-11-11 - Fastelbja : nrsamples count fixed
			vag->nrsamples = (get32bitL(readbuf+0x38)*28/16)/2;

			// 2007-11-11 - Fastelbja : interleave (*2) is on 0x04 
			vag->ch[1].interleave=vag->ch[0].interleave=0x10;

			// HACK
			if(vag->NCH == 1)
				vag->ch[1].interleave=vag->ch[0].interleave=0xffffffff;
			
			// 2007-11-11 - Fastelbja : chanstart value is on 0x10
			vag->ch[0].chanstart=0x40;
			vag->ch[1].chanstart=vag->ch[0].chanstart+vag->ch[0].interleave;

			// 2007-11-11 - Fastelbja : Loop entry point is on 0x14
			//							End loop point is always end of file
			vag->ch[0].sa=vag->ch[1].sa=get32bitL(readbuf + 0x3C);
			vag->ch[0].ea=vag->ch[1].ea=vag->file_length;
			vag->ch[0].bps=vag->ch[1].bps=8;

			if (vag->ch[0].sa==0xffffffff)
			{
				vag->ch[0].loop_flag=vag->ch[1].loop_flag=0;
				vag->ch[0].ea=vag->ch[1].ea=0;
				vag->ch[0].sa=vag->ch[1].sa=0;
			}
			else
				vag->ch[0].loop_flag = vag->ch[1].loop_flag = 1;
		} else if(!memcmp(readbuf, " KPV", 4)) {
			// VPK Fomart
			vag->ch[0].type=type_vpk;
			vag->NCH = get32bitL(readbuf+0x14);
			vag->ch[1].sample_rate = vag->ch[0].sample_rate = get32bitL(readbuf+0x10);
			vag->nrsamples = get32bitL(readbuf+0x4)*28/16;
			vag->ch[1].interleave=vag->ch[0].interleave=get32bitL(readbuf+0x0c)/2;
			vag->ch[0].chanstart=get32bitL(readbuf + 0x08);
			vag->ch[1].chanstart=vag->ch[0].chanstart+vag->ch[0].interleave;
		} else if(!memcmp(readbuf, "MUSC", 4)) {
			// MUSC Fomart
			vag->ch[0].type=type_musc;
			vag->NCH = 2;
			vag->ch[1].sample_rate = vag->ch[0].sample_rate = get32bitL(readbuf+0x06);
			vag->nrsamples = (vag->file_length*28/16)/2;
			vag->ch[1].interleave=vag->ch[0].interleave=get32bitL(readbuf+0x18)/2;
			vag->ch[0].chanstart=get32bitL(readbuf + 0x10);
			vag->ch[1].chanstart=vag->ch[0].chanstart+vag->ch[0].interleave;
		} else if(!memcmp(readbuf, "RSD6", 4)) {
			// RSD6
			vag->ch[0].type=type_rsd6;
			vag->NCH = get32bitL(readbuf+0x08);
			vag->ch[1].sample_rate = vag->ch[0].sample_rate = get32bitL(readbuf+0x10);
			vag->nrsamples = (vag->file_length*28/16)/2;
			vag->ch[1].interleave=vag->ch[0].interleave=get32bitL(readbuf+0x0C);
			vag->ch[0].chanstart=0x800;
			vag->ch[1].chanstart=vag->ch[0].chanstart+vag->ch[0].interleave;
		} else if(!memcmp(readbuf,"FSB",3)) {
			// FSB PS2
			if((get32bitL(readbuf+0x48)== (int)0x00880042) ||
			  (get32bitL(readbuf+0x48)== (int)0x00880041) ||
			  (get32bitL(readbuf+0x48)== (int)0x00880040))
			{
				vag->ch[0].type = type_ps2fsb;
				vag->NCH = 2;
	            vag->file_length = get32bitL(readbuf + 0x0c) + 0x58;
				vag->nrsamples = (vag->file_length *28/16)/2;
				vag->ch[0].chanstart = 0x58;
				vag->ch[0].sample_rate=vag->ch[1].sample_rate=get32bitL(readbuf+0x4c);
                vag->ch[0].interleave=vag->ch[1].interleave= 0x10;
				vag->ch[1].chanstart=vag->ch[0].chanstart+vag->ch[0].interleave;
			}
			else {
				CloseCUBEFILE(vag);
				return 1;
			}

		} else if(!memcmp(readbuf,"Svag",4)) {
			// FSB PS2
			if(get32bitL(readbuf+0x0c)<= (int)0x00000002)
			{
				vag->ch[0].type = type_svag;
				vag->NCH = get32bitL(readbuf+0x0c);
				vag->nrsamples = (get32bitL(readbuf+0x04) *28/16)/vag->NCH;

				if(!memcmp(readbuf+0x1c," ALL",4))
					vag->ch[0].chanstart=0x800;
				else
					vag->ch[0].chanstart = 0x400;
				vag->ch[0].sample_rate=vag->ch[1].sample_rate=get32bitL(readbuf+0x08);
                vag->ch[0].interleave=vag->ch[1].interleave= get32bitL(readbuf+0x10);

				if (vag->ch[0].interleave==0)
					vag->ch[0].interleave=vag->ch[1].interleave=0x10;

				vag->ch[1].chanstart=vag->ch[0].chanstart+vag->ch[0].interleave;

				vag->ch[0].sa=vag->ch[1].sa=((get32bitL(readbuf + 0x18))*28/16); //+vag->ch[0].chanstart;
				vag->ch[0].ea=vag->ch[1].ea=vag->file_length;
				vag->ch[0].bps=vag->ch[1].bps=8;

				if (vag->ch[0].sa==0)
				{
					vag->ch[0].loop_flag=vag->ch[1].loop_flag=0;
					vag->ch[0].ea=vag->ch[1].ea=0;
					vag->ch[0].sa=vag->ch[1].sa=0;
				}
				else
					vag->ch[0].loop_flag = vag->ch[1].loop_flag = 1;
			}
		}

		else if(!memcmp(readbuf,"RSTM",4)) {
			// RSTM
			if((get32bitL(readbuf+0x0c)== (int)0x00000002) && (memcmp(readbuf+0x40,"HEAD",4)))
			{
				vag->ch[0].type = type_rstm;
				vag->NCH = 2;
				vag->nrsamples = (get32bitL(readbuf+0x18) *28/16)/2;
				vag->ch[0].chanstart = 0x800;
				vag->ch[0].sample_rate=vag->ch[1].sample_rate=get32bitL(readbuf+0x08);
                vag->ch[0].interleave=vag->ch[1].interleave= get32bitL(readbuf+0x1c)/2;
				vag->ch[1].chanstart=vag->ch[0].chanstart+vag->ch[0].interleave;

				vag->ch[0].sa=vag->ch[1].sa=get32bitL(readbuf + 0x24)*28/16;
				vag->ch[0].ea=vag->ch[1].ea=get32bitL(readbuf + 0x20);
				vag->ch[0].bps=vag->ch[1].bps=16;

				if (vag->ch[0].sa==0xFFFFFFFF)
				{
					vag->ch[0].loop_flag=vag->ch[1].loop_flag=0;
					vag->ch[0].ea=vag->ch[1].ea=0;
					vag->ch[0].sa=vag->ch[1].sa=0;
				}
				else
				{
					vag->ch[0].loop_flag = vag->ch[1].loop_flag = 1;
					vag->ch[0].sa = vag->ch[0].sa - get32bitL(readbuf + 0x20);
				}
			}
			else {
				CloseCUBEFILE(vag);
				return 1;
			}
		}
		else if ((get32bitL(readbuf) == 0x08640001) &&
                 (get32bitL(readbuf + 4) == 0) &&
                 (get32bitL(readbuf + 8) == 0x800) &&
                 (get32bitL(readbuf + 16) == 0) &&
                 (get32bitL(readbuf + 20) == 0) &&
                 (get32bitL(readbuf + 24) == 0xac44))
		{
            vag->ch[0].type = type_kecs;
            vag->ch[0].sample_rate=vag->ch[1].sample_rate = (int)get32bitL(readbuf + 0x18);
            vag->NCH = (int)get32bitL(readbuf + 0x1c);
            vag->nrsamples = ((vag->file_length - 0x800) / 16 * 28)/vag->NCH;
			vag->ch[0].interleave=vag->ch[1].interleave=get32bitL(readbuf + 0x24);
			if (vag->ch[0].interleave==0)
				vag->ch[0].interleave=vag->ch[1].interleave=0x10;
			vag->ch[0].chanstart=get32bitL(readbuf + 0x08);
			vag->ch[1].chanstart=vag->ch[0].chanstart+vag->ch[0].interleave;
        }

		else
		{
			CloseCUBEFILE(vag);
			return 1;
		}
	}
	
	if(vag->NCH==1)
		vag->ch[0].interleave=vag->ch[1].interleave=0x10;

	vag->ch[0].offs=vag->ch[0].chanstart;
	vag->ch[1].offs=vag->ch[1].chanstart;
	SetFilePointer(vag->ch[0].infile,vag->ch[0].chanstart,0,FILE_BEGIN);

	if (vag->ch[0].loop_flag)
	vag->nrsamples=(vag->ch[0].sa-vag->ch[0].chanstart+(vag->ch[0].ea-vag->ch[0].sa)*looptimes)*28/16/vag->NCH+(fadelength+fadedelay)*vag->ch[0].sample_rate;
	return 0;
}

void fillbufferVAG(CUBEFILE * vag) {
	int l;
	char ADPCMbuf[16];

	if (SetFilePointer(vag->ch[0].infile,0,0,FILE_CURRENT) >= vag->file_length) {
		vag->ch[0].readloc=vag->ch[0].writeloc-1;
		return;
	}

	do {
		ReadFile(vag->ch[0].infile, ADPCMbuf, 16, &l, NULL);
		if (l<16) return;
		VAGdecodebuffer(ADPCMbuf,vag->ch[0].chanbuf+vag->ch[0].writeloc,
					&vag->ch[0].hist1, &vag->ch[0].hist2);

		vag->ch[0].writeloc+=28;

		if (vag->ch[0].writeloc>=BUFFER_SIZE/8*14) vag->ch[0].writeloc=0;
	} while (vag->ch[0].writeloc != vag->ch[0].readloc);
}

void fillbufferVAGinterleave(CUBEFILE * vag) 
{
    int l,i,j;
    char ADPCMbuf[16];
	byte ADPCMbufEmpty = 0;
	short sample;

    do 
	{
		if((((vag->ch[0].offs - vag->ch[0].chanstart) % vag->ch[0].interleave)==0) && (vag->ch[0].offs!=vag->ch[0].chanstart))
		{
			if(vag->ch[0].interleave!=0x10)
				vag->ch[0].offs+=vag->ch[0].interleave;
			if((vag->ch[0].interleave==0x10) && (vag->NCH==2) && (vag->ch[0].type!=type_vag_2ch))
				vag->ch[0].offs+=vag->ch[0].interleave;
		}

		SetFilePointer(vag->ch[0].infile, vag->ch[0].offs,0,FILE_BEGIN);
		ReadFile(vag->ch[0].infile,ADPCMbuf,16,&l,NULL);

		/*if(l==0)
			return;*/

		// Check if we get an empty buffer
		ADPCMbufEmpty=1;	

		for (i=0; i<16; i++)
		{
			if(ADPCMbuf[i]!=0)
				ADPCMbufEmpty = 0;
		}

		// if we get to the end of file (with no more reads), or empty buffer
		// make the loop if one have been set
		if (((l==0) || (ADPCMbufEmpty==1)) && (vag->loopsamplesdone!=0 && vag->ch[0].loop_flag))
		{
			vag->ch[0].offs=vag->loopsamplesdone;
			vag->ch[1].offs=vag->ch[0].offs + vag->ch[0].interleave;
			SetFilePointer(vag->ch[0].infile, vag->ch[0].offs,0,FILE_BEGIN);
			ReadFile(vag->ch[0].infile,ADPCMbuf,16,&l,NULL);
		}

		// Fill buffer to not hear click 
	    if (((vag->ch[0].type==type_svag) && (vag->samplesdone<(28*4*2))) ||
			(vag->ch[0].type==type_psh) && (vag->samplesdone<28*2))
        {
            for(i=0; i<16;i++)
                ADPCMbuf[i]=0;
        }

		if (vag->uncompressed==0)
		{
			if (ADPCMbuf[1]!=0x07)
			{
				VAGdecodebuffer(ADPCMbuf,vag->ch[0].chanbuf+vag->ch[0].writeloc,&vag->ch[0].hist1,&vag->ch[0].hist2);
				vag->ch[0].offs+=16;
				vag->ch[0].writeloc+=28;
				vag->samplesdone+=28;
			}
			else
				if (vag->NCH==1)
					return;
		}
		else
		{
            // Just copy buf to channel ...
            for (i = 0, j = 0; i < 8; i++, j+=2)
			{
				sample = get16bitL(ADPCMbuf + j);
				vag->ch[0].chanbuf[vag->ch[0].writeloc++] = sample;
			}
			vag->ch[0].offs+=16;
		}                   

	    if (vag->ch[0].writeloc>=BUFFER_SIZE/8*14) vag->ch[0].writeloc=0;

		// Set the loop point ...
		if((vag->loopsamplesdone==0) && 
			((vag->samplesdone/vag->NCH) >=(long)vag->ch[0].sa) && (vag->ch[0].loop_flag!=0))
		{
			if ((vag->ch[0].type==type_rxws))
				vag->loopsamplesdone=vag->ch[0].sa+vag->ch[0].chanstart;
			else
				vag->loopsamplesdone=vag->ch[0].offs; // SetFilePointer(vag->ch[0].infile,0,0,FILE_CURRENT);

		}

		//if ((vag->ch[0].offs-vag->ch[0].chanstart)%vag->ch[0].interleave==0) vag->ch[0].offs+=vag->ch[0].interleave;

		if(vag->NCH==2)
		{
			SetFilePointer(vag->ch[1].infile, vag->ch[1].offs,0,FILE_BEGIN);
			ReadFile(vag->ch[1].infile,ADPCMbuf,16,&l,NULL);

			// Fill buffer to not hear click 
			if ((vag->ch[0].type==type_svag) && (vag->samplesdone<(28*4*2)))
			{
				for(i=0; i<16;i++)
					ADPCMbuf[i]=0;
			}

		}

		if (vag->uncompressed==0)
		{
			if (ADPCMbuf[1]!=0x07)
			{
				VAGdecodebuffer(ADPCMbuf,vag->ch[1].chanbuf+vag->ch[1].writeloc,&vag->ch[1].hist1,&vag->ch[1].hist2);
				vag->ch[1].offs+=16;
				vag->ch[1].writeloc+=28;
				vag->samplesdone+=28;
			}
			else
				return;
		}
		else
		{
			// Just copy buf to channel ...
			for (i = 0, j = 0; i < 8; i++, j+=2)
			{
				sample = get16bitL(ADPCMbuf + j);
				vag->ch[1].chanbuf[vag->ch[1].writeloc++] = sample;
			}
			vag->ch[1].offs+=16;
		}                   

		if((((vag->ch[1].offs - vag->ch[1].chanstart) % vag->ch[1].interleave)==0) && (vag->ch[1].offs!=vag->ch[1].chanstart))
		{
			if(vag->ch[1].interleave!=0x10)
				vag->ch[1].offs+=vag->ch[1].interleave;
			if((vag->ch[1].interleave==0x10) && (vag->NCH==2) && (vag->ch[0].type!=type_vag_2ch))
				vag->ch[1].offs+=vag->ch[1].interleave;
		}

		if (vag->ch[1].writeloc>=BUFFER_SIZE/8*14) vag->ch[1].writeloc=0;

    } while (vag->ch[0].writeloc != vag->ch[0].readloc);
}

void fillbufferVS(CUBEFILE * vag) 
{

    byte ADPCMbuf[0x10];
    byte ADPCMread[0x4000];
    int ADPCMLength=0,i,j,l;

	
	for(j=0;j<vag->NCH;j++)
	{
		vag->ch[j].bufferOffset=0;

		SetFilePointer(vag->ch[0].infile, vag->ch[0].offs,0,FILE_BEGIN);
		ReadFile(vag->ch[0].infile,&ADPCMLength,4,&l,NULL);
		//SetFilePointer(vag->ch[j].infile, ADPCMLength+4,0,FILE_CURRENT);
		vag->ch[0].offs+=ADPCMLength+4;

		ReadFile(vag->ch[0].infile,ADPCMread,ADPCMLength,&l,NULL);

	    // Say the thread we get to the end of file (with no loop)
		if (l != 0)
		{
			// Ok then decode the buffer
			do
			{
				for (i = 0; i < 0x10; i++)
					ADPCMbuf[i] = ADPCMread[i + vag->ch[j].bufferOffset];
				VAGdecodebuffer(ADPCMbuf,vag->ch[j].chanbuf+vag->ch[j].writeloc,&vag->ch[j].hist1,&vag->ch[j].hist2);
				
				vag->ch[j].writeloc+=28;

				if (vag->ch[j].writeloc>=BUFFER_SIZE/8*14) 
					vag->ch[j].writeloc=0;

				vag->ch[j].bufferOffset+=0x10;
				ADPCMLength -= 0x10;
			} while (ADPCMLength>0);
		}
	}
}

