#include <audacious/util.h>
#include "data.h"

InputPlugin cube_iplug = {
  .description = "Cube Decoder",
  .init = cube_init,
  .about = cube_about,
  .configure = cube_configure,
  .cleanup = cube_destroy,
  .is_our_file = cube_is_our_file,
  .play_file = cube_play,
  .stop = cube_stop,
  .pause = cube_pause,
  .seek = cube_seek,
  .get_time = cube_get_time,
  .get_song_info = cube_get_song_info,
  .vfs_extensions = cube_exts,
  .mseek = cube_mseek,
  .file_info_box = cube_file_info_box,
};

gchar *cube_exts [] = {
    /* DSP audio files */
    "dsp",		
    "gcm",
    "hps",
    "idsp",
    "spt",
    "spd",
    "mss",
    "mpdsp",
    "ish",
    "ymf",
    "wam",
    "wac",
    "wad",
    "waa",
    "wvs",
    "thp",
    "adx",
    "adp",
    "rsd",
    "rsp",
    "ast",
    "afc",
    "vag",
    "ads",
    "npsf",
    "ss2",
    "rws",
    "rxw",
    "svag",
    "mib",
    "psh",
    "vpk",
    "mus",
    "ccc",
    "fsb",
    "fag",
    "vs",
    "tgt",
    "i80",
    "i100",
    "stm",
    "rstm",
    "ass",
    "kces",
    "psw",
    "musc",
    "rsd6",
    "rkv",
    "mic",
    "xa",
    "str",
    "asf",
    "sng",
    "eam",
    "wavm",
    "rawx",
    "xmu",
    "xms",
    "xwav",
    "raw",
    "rwx",
    "rwsd",
    "brstm",
    "gca",
    "zwdsp",
    "kraw",
    "asr",
    "strm",
    "swav",
    /* terminator */
    NULL
  };


